* external data 						   :noexport:
#+BEGIN_SRC emacs-lisp
  (url-copy-file "http://orgmode.org/img/org-mode-unicorn-logo.png" "/tmp/logo.png" t)
  (with-temp-buffer
    (insert "
     @Article{smith88,
    author =       {lastname, firstname},
    title =        {title},
    year =         1988,
    journal =      {journal}}")
    (write-region (point-min) (point-max) "/tmp/lit.bib"))
#+END_SRC

#+RESULTS:

* cite-code 							   :noexport:
#+BEGIN_SRC emacs-lisp
  (require 'ox-odt)
  (require 'bibtex)
  (require 'reftex-cite)
  (add-to-list 'bibtex-files "/tmp/lit.bib")

  (org-add-link-type "parencite" 'identity
                     (lambda (path description backend)
                       (rasmus/org-cite-format path description backend "parencite")))

  (defconst rasmus/org-cite-re
    "\\`\\([^@]*\\|\\([^@]*\\)@\\([^ \t]*\\)\\([^@]*\\)\\)\\'"
    "Slot 1: *common* pre- or post-note.
  Slot 2: pre-note.
  Slot 3: key.
  Slot 4: post note.")

  (defun rasmus/format-plaintext (cite &optional no-year no-author)
    (let ((post (org-string-nw-p (plist-get cite :post)))
          (pre (org-string-nw-p (plist-get  cite  :pre))))
      (format "%s%s %s%s"
              (if pre (concat (org-trim (plist-get cite :pre)) " ") "")
              (if no-author "" (plist-get cite :author))
              (if no-year "" (plist-get cite :year))
              (if post (concat " " post) ""))))

  (defun rasmus/org-cite-interpret-string (string)
    "Interpret at string according to `rasmus/org-cite-re'"
    (mapcar
     (lambda (data)
       (string-match rasmus/org-cite-re data)
       (list :key  (org-string-nw-p (match-string 3 data))
             :pre  (org-trim (or (match-string 2 data)
                                 (match-string 1 data) ""))
             :post (org-trim (or (match-string 4 data) ""))))
     (org-split-string (org-link-unescape string) ";")))


  (defun rasmus/org-cite-format (path description backend type)
    "Interpret a citation link and return a latex citation." 
    (let* ((citations (rasmus/org-cite-interpret-string path)))
      (let ((textcitations
             (mapcar
              (lambda (cite)
                (let ((entry (progn (bibtex-search-entry (plist-get cite :key) t 0)
                                    (bibtex-parse-entry)))
                      (reftex-cite-punctuation '(", " " and " " et al.")))
                  (if entry
                      (list :author (or (org-remove-double-quotes
                                         (reftex-format-citation entry "%2a")) "")
                            :year (org-remove-double-quotes
                                   (reftex-format-citation entry "%y"))
                            :pre (plist-get cite :pre)
                            :post (plist-get cite :post))
                    (error "failed to find %s" (plist-get cite :key)))))
              citations)))
        (if (equal type "parencite")
            (format "(%s)" (mapconcat 'rasmus/format-plaintext textcitations "; "))))))
#+END_SRC

* fails when both elm1 and elm2 are exported

** elm 1
 para [[parencite:@smith88]] para

** elm 2
 #+NAME: name
 #+CAPTION: cap
 [[file:logo.png]]


